function [Fit_and_p,bsf_solution, fitMaxVector] = GSKIF(parameters,caseStudyData,otherParameters,low_habitat_limit,up_habitat_limit)

global No_solutions ;

problem_size =  numel(up_habitat_limit);

qq = problem_size/20 ;
num_dig = floor(log10(abs(qq)+1)) + 1;
pow_10 = 10.^(num_dig-1);
pop_size = round(qq/pow_10)*pow_10;
%fid = fopen('T1.csv','w');
No_solutions=pop_size;

g=1;

max_nfes = parameters.max_nfes;
max_gen = max_nfes / pop_size;
fnc=  otherParameters.fnc;
update_K = parameters.update_K;

%%  parameter settings for pop-size
FVr_minbound = low_habitat_limit;
FVr_maxbound = up_habitat_limit;
minPositionsMatrix=repmat(FVr_minbound,pop_size,1);
maxPositionsMatrix=repmat(FVr_maxbound,pop_size,1);



%% Initialize the main population
if(parameters.deeper_r)
    popold = dlmread('best.txt','	');
else
    popold = unifrnd(minPositionsMatrix,maxPositionsMatrix,pop_size,problem_size);
end
pop = popold; % the old population becomes the current population
[fitness, ~] = feval(fnc,pop,caseStudyData,otherParameters);

nfes = 0;
bsf_fit_var = 1e+300;

for i = 1 : pop_size
    nfes = nfes + 1;
    %%      if nfes > max_nfes; exit(1); end
    if nfes > max_nfes; break; end
    if fitness(i) < bsf_fit_var
        bsf_fit_var = fitness(i);
        bsf_solution = pop(i,:);
    end
end

Fit_and_p=[bsf_fit_var 0];
%%POSSIBLE VALUES FOR KNOWLEDGE RATE K%%%%
K=[];
%KF=[];
%KR=[];
Kind=rand(pop_size, 1);
%%%%%%%%%%%%%%%%%%%K uniform rand (0,1) with prob 0.5 and unifrom integer [1,20] with prob 0.5
K(Kind<0.5,:)= rand(sum(Kind<0.5), 1);
K(Kind>=0.5,:)=ceil(20 * rand(sum(Kind>=0.5), 1));
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


%% main loop
poww = parameters.poww;
KF_pool =parameters.KF_pool;% (unidrnd(10,1,4) + 40) / 100 ; %poissrnd(7,1,4) ; %=[0.8 1.0 0.6 0.9];%= betarnd(0.5,0.5,1,4);%[0.8 1.0 0.6 0.9];
KR_pool = parameters.KR_pool; 
prob = parameters.prob;
%KW_ind= randKW();
KW_ind=parameters.KW_ind;
All_Imp=zeros(1,4);
fitMaxVector(1,g) = bsf_fit_var;
g = g+1;

while g < max_gen
    
    g=g+1;
    jF = n_limits(0,max_gen,update_K,1,g);     
    KW_ind=jF*KW_ind+(1-jF)*All_Imp;
    KW_ind=KW_ind./sum(KW_ind);
    K_rand_ind = selectRandIndex(KW_ind,pop_size);           
    KF=KF_pool(K_rand_ind)';
    KR=KR_pool(K_rand_ind)';
            
    D_Gained_Shared_Junior=ceil((problem_size)*(1-nfes / max_nfes).^K);    
    pop = popold;

    [~, indBest] = sort(fitness, 'ascend');
    [Rg1, Rg2, Rg3] = Gained_Shared_Junior_R1R2R3(indBest);

    [R1, R2, R3] = Gained_Shared_Senior_R1R2R3(indBest,prob);
    R01=1:pop_size;
    Gained_Shared_Junior=zeros(pop_size, problem_size);
    ind1=fitness(R01)>fitness(Rg3);
    
    a = (max_gen-g)/max_gen;
    ginv=exp((1-(1/a^(poww))));
    if(sum(ind1)>0)
        Gained_Shared_Junior (ind1,:)=  pop(ind1,:)  + KF(ind1, ones(1,problem_size)).* (pop(Rg1(ind1),:) -  (pop(Rg2(ind1),:))) + ginv*KF(ind1, ones(1,problem_size)).*(pop(Rg3(ind1), :)- pop(ind1,:) ) ;
    end
    ind1=~ind1;
    if(sum(ind1)>0)
        Gained_Shared_Junior(ind1,:) =  pop(ind1,:)  + KF(ind1, ones(1,problem_size)) .* (pop(Rg1(ind1),:) - pop(Rg2(ind1),:))+ginv*KF(ind1, ones(1,problem_size)).*( pop(ind1,:)-pop(Rg3(ind1), :) );
    end
    
    
    R0=1:pop_size;
    Gained_Shared_Senior=zeros(pop_size, problem_size);
    ind=fitness(R0)>fitness(R2);
    if(sum(ind)>0)
        Gained_Shared_Senior(ind,:) =  pop(ind,:) +  KF(ind, ones(1,problem_size)) .* (pop(R1(ind),:) - pop(ind,:)) + ginv*KF(ind, ones(1,problem_size)).*(pop(R2(ind),:) - pop(R3(ind), :)) ;
    end
    ind=~ind;    
    if(sum(ind)>0)
        Gained_Shared_Senior(ind,:) =  pop(ind,:) + KF(ind, ones(1,problem_size)) .* (pop(R1(ind),:) - pop(R2(ind),:)) + ginv*KF(ind, ones(1,problem_size)).*( pop(ind,:) - pop(R3(ind), :)) ;
    end
    
    Gained_Shared_Junior = boundConstraint(Gained_Shared_Junior,minPositionsMatrix,maxPositionsMatrix);         
    
    Gained_Shared_Senior = boundConstraint(Gained_Shared_Senior,minPositionsMatrix,maxPositionsMatrix);         
    

    D_Gained_Shared_Junior_mask=rand(pop_size, problem_size)<=(D_Gained_Shared_Junior(:, ones(1, problem_size))./problem_size); % mask is used to indicate which elements of will be gained
    D_Gained_Shared_Senior_mask=~D_Gained_Shared_Junior_mask;

    D_Gained_Shared_Junior_rand_mask=rand(pop_size, problem_size)<=KR(:,ones(1, problem_size));
    D_Gained_Shared_Junior_mask=and(D_Gained_Shared_Junior_mask,D_Gained_Shared_Junior_rand_mask);

    D_Gained_Shared_Senior_rand_mask=rand(pop_size, problem_size)<=KR(:,ones(1, problem_size));
    D_Gained_Shared_Senior_mask=and(D_Gained_Shared_Senior_mask,D_Gained_Shared_Senior_rand_mask);
    ui=pop;

    ui(D_Gained_Shared_Junior_mask) = Gained_Shared_Junior(D_Gained_Shared_Junior_mask);
    ui(D_Gained_Shared_Senior_mask) = Gained_Shared_Senior(D_Gained_Shared_Senior_mask);

    [children_fitness, ~] = feval(fnc,ui,caseStudyData,otherParameters);
    %%% Updating individuals %%%
    for i = 1 : pop_size
        nfes = nfes + 1;
        if nfes > max_nfes; break; end
        if children_fitness(i) < bsf_fit_var
            bsf_fit_var = children_fitness(i);
            bsf_solution = ui(i, :);
        end
    end
   
    %%%%  Calculate the improvemnt of each settings %%%
    dif = abs(fitness - children_fitness);
    %% I == 1: the parent is better; I == 2: the offspring is better
    Child_is_better_index = (fitness > children_fitness);        
    All_Imp=zeros(1,4);% (1,4) delete for 4 cases
    for i=1:4
        if(sum(and(Child_is_better_index,K_rand_ind==i))>0)
            All_Imp(i)=sum(dif(and(Child_is_better_index,K_rand_ind==i)));
        end
    end

    if(sum(All_Imp)~=0)
        All_Imp=All_Imp./sum(All_Imp);
        [~,Imp_Ind] = sort(All_Imp);
        for imp_i=1:length(All_Imp)-1
            All_Imp(Imp_Ind(imp_i))=max(All_Imp(Imp_Ind(imp_i)),0.05); 
        end
        All_Imp(Imp_Ind(end))=1-sum(All_Imp(Imp_Ind(1:end-1)));
    else
        Imp_Ind=1:length(All_Imp);        
        All_Imp(:)=unifrnd(0,0.3,1,4);%1/length(All_Imp);                
    end
    
    
    
    [fitness, Child_is_better_index] = min([fitness, children_fitness], [], 2);

    popold = pop;
    popold(Child_is_better_index == 2, :) = ui(Child_is_better_index == 2, :);              

    
    fitMaxVector(1,g) = bsf_fit_var;
    
    %fprintf(fid,'%f\n',bsf_fit_var);

end
if(parameters.deeper_w)    
    dlmwrite('best.txt',popold,'Delimiter','\t')    
end
fprintf('%f\n', bsf_fit_var);
end

function K_rand_ind = selectRandIndex(KW_ind,pop_size)
    K_rand_ind=rand(pop_size, 1);
    K_rand_ind(K_rand_ind>sum(KW_ind(1:3))&K_rand_ind<=sum(KW_ind(1:4)))=4;
    K_rand_ind(K_rand_ind>sum(KW_ind(1:2))&K_rand_ind<=sum(KW_ind(1:3)))=3;
    K_rand_ind(K_rand_ind>KW_ind(1)&K_rand_ind<=sum(KW_ind(1:2)))=2;    
    K_rand_ind(K_rand_ind>0&K_rand_ind<=KW_ind(1))=1;
end


function x = n_limits(a,b,c,d, t)
	x = c+((d-c)/(b-a))*(t-a);
end
